#include <unistd.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/file.h>
#include <linux/kd.h>
#include <string.h>
#include <strings.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <ctype.h>
#include <limits.h>
#include <sys/mman.h>

typedef unsigned short Uint16;

int fbdev;
Uint16 *realfb;


void blitter_init(void)
{
	int fd = open("/dev/console", O_NONBLOCK);
	
	if (fd < 0)
	{
		fprintf(stderr, "Graphics mode could not be set!\n");
		exit(-1);
	}
	
	ioctl(fd, KDSETMODE, KD_GRAPHICS);
	close(fd);

	fbdev=open("/dev/fb0", O_RDWR);
	realfb=(Uint16 *)mmap(0, 320*240*sizeof(Uint16), PROT_WRITE, MAP_SHARED, fbdev, 0);
}

void blitter_finish(void)
{
	munmap(realfb, 320*240*sizeof(Uint16));
        close(fbdev);

	int fd = open("/dev/console", O_NONBLOCK);	
	
	if (fd < 0)
	{
		fprintf(stderr, "Text mode could not be set!\n");
		exit(-1);
	}
	
	ioctl(fd, KDSETMODE, KD_TEXT);
	close(fd);
}

void blitter_blit_fullscreen( void* fb )
{
	memcpy(realfb, fb, 320*240*sizeof(Uint16));
}
